//+------------------------------------------------------------------+
//|                                       FXA0 - Stomper 4H ver1.mq4 |
//|                            Copyright  2007 Adam J. Richter M.S. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Adam J. Richter M.S."
#property link      ""

//WORKING NOTES
//RIGHT NOW IS SET TO DOUBLE UP ON upper level crosses
//Looses money in sideways markets
//There are moves to be caught from below 50 to above 50
//Stop and Target should be dynamic - may need to redefine entry and exits
//may need timefilter
//If current RSI>50 > than lastRSI>50 and RSI before that<50 add one long position to RSI cross down 60
   //If RSI two bars ago is below 50 and RSI now above 50 and no active entries, enter at market
   //Sometimes move is not fully realized until two RSI past, 
   //so if the current bar is above 50 and the last two bars were below and no entries, go long.
   //MISSING Moves because fluctuation in bar, if it goes up and down a lot the RSI may end up looking for longs
//Possibly use channels like MakeGrid EA
//Possibly use 10points in sideways market...
//Use other indicators for directions


extern double ATR_Percent = 0.15;  //This value sets the ATR Used, 1.65 is optimized value but very few trades
extern double ATR_PercentStop = 0.30;
extern double RSI_Period = 21;  //This value sets the RSI Period Used, The default is 21
extern double ATR_Period = 21;  //This value sets the ATR Period Used, The default is 21

extern bool UseMM = 0;   // 1 = true & 0 = false
extern double Risk = 6.0; // Risk should be divisible by 2
extern double NoMMLots = 0.1; // lots is used if UseMM = false
extern int AccountisNormal = 0; //1 if Standard Account, Standard will use full Lots, 0 if Mini
double Lots = 0.1; //this is used if Money Management is active

//RSI Levels for Buy and Sells
double RSIup2 = 70;
double RSIup1 = 60;
double RSIdown1 = 40;
double RSIdown2 = 30;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator buffers mapping ----//
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----  ----//
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
      if (AccountisNormal==1) 
      { 
         if (UseMM) { Lots=MathCeil(AccountBalance()*(Risk/2)/10000); }
         else { Lots=NoMMLots; }
      } 
      else //Mini Account
      {  
         if (UseMM) { Lots=MathCeil(AccountBalance()*(Risk/2)/10000)/10; }
         else { Lots=NoMMLots; }
      }
   
   int ticket, total, cnt, cntb, totalb;
   bool order1; 
   bool order2; 
   double entry, stop, newentry, newstop;
   double myRSInow = iRSI(Symbol(),0,RSI_Period,PRICE_CLOSE,0);//Testing current bar RSI Ask
   double myRSIlast = iRSI(Symbol(),0,RSI_Period,PRICE_CLOSE,1); //One RSI Ago
   double myATRnow = iATR(Symbol(),PERIOD_D1,ATR_Period,0);
   
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);
   }

//+------------------------------------------------------------------+
//| going long                                                       |
//+------------------------------------------------------------------+
   if (myRSInow>=50)
   {
      //close any short positions
      total=OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderMagicNumber() == 77771)
         {
            if(OrderType()==OP_SELLSTOP) { OrderDelete(OrderTicket()); }  //close pending
            if(OrderType()==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),Ask,3,Red); } //close Open 
         }
         if(OrderMagicNumber() == 77772) { OrderClose(OrderTicket(),OrderLots(),Ask,3,Red); }  //close Open
      }
      if(myRSInow>=50 && myRSIlast<50) //if it crossed from below 50 then open first order
      {
         order1=0;
         total = OrdersTotal();
         for(cnt=0;cnt<total;cnt++)//cylce through open orders to see if order 1 exists
         {
            if(OrderMagicNumber() == 88881) { order1=1; }
         }
         if(!order1) //if order1 doesn't exist then open it
         {
               stop = NormalizeDouble(Ask+(myATRnow*ATR_Percent)-(myATRnow*ATR_PercentStop),4); 
               //stop = NormalizeDouble(((iHigh(Symbol(),0,1)+(myATRnow*ATR_Percent))-(0.30*myATRnow)),4);   
               //(Low[iLowest(NULL,0,MODE_LOW,1,0)])-6*Point
               entry = NormalizeDouble(Ask+(myATRnow*ATR_Percent),4); 
               //entry = NormalizeDouble((iHigh(Symbol(),0,1)+(myATRnow*ATR_Percent)),4);
               ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,entry,3,stop,0,"Stomp Long 1",88881,0,Blue);
               if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("STOMP BUY order 1 opened: ",OrderOpenPrice()); }
               else Print("Error opening STOMP BUY order 1: Entry " + entry + " Stop " + stop,GetLastError());
         }
      }////
      if(myRSInow>=RSIup1 && myRSIlast<RSIup1) //add to position on cross up through level 1
      {
            order1=0;
            order2=0;
            total = OrdersTotal();
            for(cnt=0;cnt<total;cnt++)
            {
               OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
               if(OrderMagicNumber() == 88881 && OrderType()==OP_BUY) { order1=1; }//if order 1 exists and is not pending
               if(OrderMagicNumber() == 88882) { order2=1; }
            }
            if(order1 && order2) { }  //do nothing
            if(order1 && !order2) //if order one does exist and order two does not then put in order two
            {                   
               //can experiment with the stop on this, same as original or entry of original, 
               //right now there is no stop because it closes when cross below 50 RSI
               ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"Stomp Long 2",88882,0,Blue);
               if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("STOMP BUY order 2 opened: ",OrderOpenPrice()); }
               else Print("Error opening STOMP BUY order 2: ",GetLastError());
            }  
      }////
      if(myRSInow<RSIup2 && myRSIlast>=RSIup2) //close first order when RSI crosses above then back below level 2
      {
         order1=0;
         order2=0;
         total = OrdersTotal();
         for(cnt=0;cnt<total;cnt++) //find open long orders
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if(OrderMagicNumber()==88881 && OrderType()==OP_BUY) { order1=1; }
            if(OrderMagicNumber()==88882) { order2=1; }
         }
         if(order1 && order2) //if both orders are open then close first order at market
         {
            totalb = OrdersTotal();
            for(cntb=0;cntb<totalb;cntb++) //find my first long order
            {
               OrderSelect(cntb, SELECT_BY_POS, MODE_TRADES);
               if(OrderMagicNumber() == 88881) { OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue); } //close order one
            }
         }
         if(!order1 && order2) { } //do nothing
      }////
   }////
   
//+------------------------------------------------------------------+
//| going short                                                      |
//+------------------------------------------------------------------+    
   if(myRSInow<50)  //is going short
   {
      //close any open long positions
      total = OrdersTotal();
      for(cnt=0;cnt<total;cnt++)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderMagicNumber() == 88881)
         {
            if(OrderType()==OP_BUYSTOP) { OrderDelete(OrderTicket()); }
            if(OrderType()==OP_BUY) { OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue); }
         }
         if(OrderMagicNumber() == 88882) { OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue); }
      }
      if(myRSInow<50 && myRSIlast>=50) //did it cross from above 50
      {
         order1=0;
         total = OrdersTotal();
         for(cnt=0;cnt<total;cnt++)
         {
            if(OrderMagicNumber() == 77771) { order1=1; }  
         } 
         if(!order1)
         {
            ticket=0;
            stop = NormalizeDouble(Bid-(myATRnow*ATR_Percent)+(myATRnow*ATR_PercentStop),4); 
            //stop = NormalizeDouble(((iLow(Symbol(),0,1)-(myATRnow*ATR_Percent))+(0.30*myATRnow)),4);   
            //(High[iHighest(NULL,0,MODE_LOW,1,0)])-6*Point
            entry = NormalizeDouble(Bid-(myATRnow*ATR_Percent),4); 
            //entry = NormalizeDouble((iLow(Symbol(),0,1)-(myATRnow*ATR_Percent)),4);
            ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,entry,3,stop,0,"STOMP Short 1",77771,0,Red);
            if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("STOMP SELL order 1 opened: ",OrderOpenPrice()); }
            else Print("Error opening STOMP SELL order 1: ",GetLastError()); 
          }
      }////
      if(myRSInow<RSIdown1 && myRSIlast>RSIdown1)
      {
         order1=0;
         order2=0;
         total = OrdersTotal();
         for(cnt=0;cnt<total;cnt++) //find open short orders
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if(OrderMagicNumber() == 77771 && OrderType()==OP_SELL) { order1=1; }
            if(OrderMagicNumber() == 77772) { order2=1; }
         }
         if(order1 && order2) { } //do nothing
         if(order1 && !order2)
         {
            ticket=0;
            ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"STOMP Short 2",77772,0,Red);
            if(ticket>0) { if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("STOMP SELL order 2 opened: ",OrderOpenPrice()); }
            else Print("Error opening STOMP SELL order 2: ",GetLastError()); 
         }  
      }////
      if(myRSInow>RSIdown2 && myRSIlast<RSIdown2)
      {
         order1=0;
         order2=0;
         total = OrdersTotal();
         for(cnt=0;cnt<total;cnt++) //find open long orders
         {
            OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
            if(OrderMagicNumber() == 77771 && OrderType()==OP_SELL) { order1=1; }
            if(OrderMagicNumber() == 77772) { order2=1; }
         }
         if(order1 && order2)
         {
            totalb = OrdersTotal();
            for(cntb=0;cntb<totalb;cntb++) //find my first long order
            {
               OrderSelect(cntb, SELECT_BY_POS, MODE_TRADES);
               if(OrderMagicNumber() == 77771) { OrderClose(OrderTicket(),OrderLots(),Ask,3,Red); }
            }
         }
         if(!order1 && order2) { }//do nothing
      }////
   }//// 
   

//----
   return(0);
  }
//+------------------------------------------------------------------+